% IMPORT DATA ECTA07

clear all; clc; close all; pause(.001);

% CHOOSE PATH WHERE TO WORK AND SAVE RESULTS
	Directory   = 'C:\';
	fpath       = strcat(Directory,'dsgevar\');
	spath       = strcat(Directory,'dsgevar\save');
	gpath       = strcat(Directory,'dsgevar\graphs\');
%     disp(['> ', Directory]); disp(' '); pause;

% UPLOAD DATA
    %=================
    StartRange      = [1960, 4];
    EndRange        = [2001, 3];
    StartTraining   = [1960, 4];
    EndTraining     = [1965, 3];        % it should be anchored to T* = lambda * T
    StartSample     = [1960, 4];        % you should look at "etrn" and T* for consistency
    EndSample       = [1997, 4];        % Ex. 1997:4
    StartFcst       = [1998, 1];        % Ex. 1998:1
    EndFcst         = [2001, 3];
    %=================
    
	global Dates
	dates       = cal(  StartRange(1), StartRange(2), 4);
	srng        = ical( StartRange(1), StartRange(2), dates);
	erng        = ical( EndRange(1)  , EndRange(2)  , dates);
	Dates       = 1960.75: .25 :2001.50;
	Dates       = Dates( :, srng : erng)';
    FlagChart   = 0;
	
	DataDNS     = xlsread([Directory, 'dsgevar\data404.xls'], 'DataCFP6001');
	DNS         = DataDNS( srng : erng, 2 : end);


% DIFF/LOG DATA
    Y   = DNS( :, 1);
    P   = DNS( :, 3);
    DY  = DNS( :, 2);
    DP  = DNS( :, 4);
    FFR = DNS( :, 5);
    F   = DNS( :, 6 : 8);
    r   = size(F, 2);
    
    ZZ          = [DY DP FFR];
    Trng        = size( ZZ, 1);
    VarLabels   = {'Real GDP Growth', 'The Inflation Rate', 'Policy Rate', 'F1 - Slow', 'F2 - Slow', 'F3 - Fast'};
    if FlagChart
        SPlot( [ZZ F], [], [], VarLabels);
    end

% CONSTRUCT  MOMENTS
    q   = 1;
    p   = 1;

    %| PRIOR    :: TRAINING SAMPLE
        strn    = ical( StartTraining(1), StartTraining(2), dates);
        etrn    = ical( EndTraining(1)  , EndTraining(2)  , dates);
        Ftrn    = F( strn : etrn , :);
        
        FtrnL   = LagbyLags( Ftrn, q );
        Ttrn    = size(FtrnL, 1);
        FFFFt   = FtrnL' * FtrnL / Ttrn;
        
        %| CHOOSE FACTORS
%             FFFFt   = FFFFt;           %! { FFFFt ,  [] }
            FFFFt=[];
            PR.FF   = FFFFt;
            r       = size(FFFFt, 2)/q;
            PR.r    = r;
                
    %| MLE      :: ESTIMATION SAMPLE { YY, XX, FF }
        ssmpl       = ical( StartSample(1), StartSample(2), dates);
	    esmpl       = ical( EndSample(1)  , EndSample(2)  , dates);
        YY          = ZZ( ssmpl : esmpl, :);
        T           = size( YY, 1);
        [XX   , YY] = LagbyLags( YY, p);
        FF          = F(  ssmpl : esmpl, :);
        
        %> RUN A VAR(1) FOR THE FACTORS FOR THE FCST EXERCISE :: Checked with EViews
            [FFt1 , FFt]= LagbyLags( FF(p:end, :), 1);
            PHI_FF      = FFt1 \ FFt;
        
        if isempty( FFFFt )
            WW      = [XX];
            q       = 0;
        else
            [FFLag, FF] = LagbyLags( FF, q);
            
            if      gt(p, q)
                WW      = [XX, FFLag( p - q + 1 : end, :) ];
            elseif  lt(p, q)
                WW      = [XX( q - p + 1 : end, :), FFLag ];
                YY      = YY( q - p + 1 : end, :);
            else
                WW      = [XX, FFLag];
            end
        end
        WW          = [ ones( T - max(p, q), 1 ), WW];      %!!  constant is first in WW
        XX          = [ ones( T - max(p, q), 1 ), XX];      %!!  constant is first in XX
        [T, k]      = size( WW );
        [T, m]      = size( YY );
        
        YYYY        = YY'*YY;
        XXYY        = XX'*YY;
        XXXX        = XX'*XX;
        WWWW        = WW'*WW;
        WWYY        = WW'*YY;
        
        MLE.WY      = WWYY;
        MLE.WW      = WWWW;
        MLE.YY      = YYYY;
        MLE.XX      = XXXX;
        MLE.XY      = XXYY;
        MLE.T       = T;
        
        
    % FORECASTING SAMPLE
        sfcst       = ical( StartFcst(1), StartFcst(2), dates);
	    efcst       = ical( EndFcst(1)  , EndFcst(2)  , dates);
        
        if  eq( esmpl, erng )
            YYout   = [];
            H       = 0;
        else
            YYout   = ZZ( esmpl + 1 : erng, :);
            H       = efcst - sfcst + 1;
        end

        % COMPANION FORM :: [ 1, y(t), ..., y(t-p+1), ..., F(t), ..., F(t-q+1) ]
        WWprd       = [ 1, YY(end, :), WW( end, 2 : 1 + m*(p - 1) ), FF(end, 1: r), WW( end, [2 + m*p : end - r]) ];
        XXprd       = [ 1, YY(end, :), XX( end, 2 : 1 + m*(p - 1) ) ];
        
    % DNS COMPARISON
        [XXall, YYall] = LagByLags( DNS( : , [2 4 5]), p );
        XXall       = [ones( Trng - p , 1), XXall ];
        YYfut       = YYout;
        nobs        = T;                                %*
        YYpre       = [];
        WWpred      = WWprd;
        XXpred      = XXprd;
        nobsall     = Trng - p;
        nobsfut     = size( YYout, 1);
        ti          = Dates( p + 1 : end, :);           %*
        datt        = [ti, YYall];                      %*  " ti " has to be consistent with " YYall ":: all loaded sample
        YYdns       = YY;                               %*
        XXdns       = WW( :, [1 : 1 + m*p ] );          %*
        nobs        = T;                                %*
        YYYYdns     = YYYY;
        XXYYdns     = WWYY( 1: 1 + m*p, : );            %*
        XXXXdns     = WWWW( 1: 1 + m*p, 1 : 1 + m*p );  %*
        
    % OUTPUT TO BE DISPLAYED
        dispcat('DATA RANGE         : ', srng, erng   );
        dispcat('TRAINING SAMPLE    : ', strn, etrn   );
        dispcat('ESTIMATION SAMPLE  : ', ssmpl, esmpl );
        dispcat('FORECASTING SAMPLE : ', sfcst, efcst );
        disp( repmat('_', 1, 75))
        dispcat('ESTIMATION #     :  ', T, '     FORECASTING #     : ', H );
        
% SAVE
    save( 'CFP_LoadDataMat' )