clear all; clc; close all; fclose('all'); pause(.001)

% UPLOAD DATA
    CFP_LoadData;

% DEFINE THE SPECIFICATION
    CFP_SPEC;    
    
% To construct string to save data
lprior    = num2str( mprior );
lmodel    = strcat('m', num2str(mspec) );
dataset   = num2str(10*dataset);
I         = find( ti == dates_dns );      % { Index of last Obs dates in DNS is = 2001.5 }
fixparam  = 0;
lambdaseq = 0;

% "SAVE" DIRECTORY
	spath       = strcat(Directory,'CFP\save');
    
%     %> FAVAR(4,0)
%         spath       = [spath(1, 1:end-4), 'save_fcst_favar40_1e5'];
%         MSFE_Label  = 'MSFE_FAVAR40';
%         
%     %> FAVAR(4,1)
%         spath       = [spath(1, 1:end-4), 'save_fcst_favar41_1e5'];
%         MSFE_Label  = 'MSFE_FAVAR41';
%     
%     %> FAVAR(4,4)
%         spath       = [spath(1, 1:end-4), 'save_fcst_favar44_1e5'];
%         MSFE_Label  = 'MSFE_FAVAR44';
%         
%     %> DSGE-FAVAR(4,0)
%         spath       = [spath(1, 1:end-4), 'save_fcst_dsgefavar40_1e5'];
%         MSFE_Label  = 'MSFE_DSGEFAVAR40';
% 
%     %> DSGE-FAVAR(4,1)
%         spath       = [spath(1, 1:end-4), 'save_fcst_dsgefavar41_1e5'];
%         MSFE_Label  = 'MSFE_DSGEFAVAR41';
%         
    %> DSGE-FAVAR(4,4)
%         spath       = [spath(1, 1:end-4), 'save_fcst_dsgefavar44_1e5'];
        spath       = [spath(1, 1:end-4), 'save'];
        MSFE_Label  = 'MSFE_DSGEVAR';
%         
%     %> DSGE
%         spath       = [spath(1, 1:end-4), 'save_fcst_dsge_1e5'];
%         MSFE_Label  = 'MSFE_DSGE';
        
        
        
% COMPUTATION OVER LAMBDAS
for lambdas = lambdaseq
    
% LOAD SIMULATED DATA : FCST
    infile3 = strcat(spath,'\pred',lmodel,lprior,dataset,new,st,num2str(100*lambdas),num2str(100*ti(I)),num2str(fixparam),num2str(JustMode));
    innum3  = nblocks*nsim*(m*H)*8;
    innumb3 =         nsim*(m*H)*8;
    
    infid3  = fopen( infile3, 'r');		        % input file (set to read)
    status  = fseek( infid3, innumb3,'bof');    % start after "nsim" burn-in simulation
    
    YYfcst = [];
	while ( ftell(infid3) < innum3 )
        
        % Read blocks of size nsim :: ORDER: [Var#1 all H ; Var#2 all H; ... ]
		YYfcst_ = fread( infid3, [ nsim, H*m ], 'double' );
        if all( size(YYfcst_,2) == H*m )
            YYfcst = [YYfcst; YYfcst_];
        else
   			fclose(infid3);
        end
        clear YYfcst_;
	
	end;
    fclose(infid3);
        
% COMPUTE MSFE FOR EACH FCST HORIZON
    fcstErr     = kron( ones( nsim*(nblocks-1), 1), YYout(:)' ) - YYfcst(:, 1 : m*H );
    MSFE        = var( fcstErr, 1);
    MSFE_m_H    = reshape(MSFE', H, m)'; % Raws are variables and across Cols we get h=1:H
    
% COMPUTE MSFE BY ENCOMPASSING FCST HORIZON
    YYfcstE     = mean( YYfcst );
    fcstErrE    = reshape( YYout(:)' - YYfcstE, H, m )';
    MSFE_E      = mean( fcstErrE.^2, 2);
    MSFE_E      = MSFE_E.^0.5;


    YYfcstD     = median( YYfcst );
    fcstErrD    = reshape( YYout(:)' - YYfcstD, H, m )';
    MSFE_D      = mean( fcstErrD.^2, 2);
    
% SAVE MSFE
    eval([ MSFE_Label, ' =  MSFE_m_H;']);
    eval([ MSFE_Label, '_E =  MSFE_E;']);
    eval([ MSFE_Label, '_D =  MSFE_D;']);
    infile6 = strcat(spath,'\msfe',lmodel,lprior,dataset,new,st,num2str(100*lambdas),num2str(100*ti(I)),num2str(fixparam),num2str(JustMode));
    save( infile6, MSFE_Label )
    save( infile6, [MSFE_Label, '_E'] )
    save( infile6, [MSFE_Label, '_D'] )
    
    MSFE_X=MSFE_E(1,1);
    
    MSFE_P=MSFE_E(2,1);
    
    MSFE_R=MSFE_E(3,1);
    
end % end loop LAMBDAS


return
% READ AND COMPARE %
load('save_fcst_favar40_1e5\msfem10124042new656020015000')
load('save_fcst_favar41_1e5\msfem10124042new656020015000')

disp( [MSFE_DSGE_FAVAR41 ; MSFE_DSGE_FAVAR40] )
RMSFE = MSFE_DSGE_FAVAR41 ./ MSFE_DSGE_FAVAR40;