% function obj = objfcn2inf      (para,YYYY,XXYY,XXXX,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,marg);
%
% Original Version : objfcn2inf.m
% See also         : CFP_ObjFcnPKhes.m

function obj = CFP_ObjFcnPKhesinf(para,YYYY,WWYY,WWWW,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,FFFFt);

	if isempty( FFFFt )    
        XXYY    = WWYY;
        XXXX    = WWWW;
        
	else
        k       = size(WWWW , 2);
        rq      = size(FFFFt, 2);
        XXYY    = WWYY(1:k-rq, :);
        XXXX    = WWWW(1:k-rq, 1:k-rq);
        
	end
    
% Likelihood 
	[TTT,RRR,valid]             = dsgesolv(para,mspec);
	[yyyyd,xxyyd,xxxxd,retcode] = varprio(TTT,RRR,valid,para,nvar,nlags,mspec,npara);
	phis                        = inv(xxxxd)*xxyyd;
	sigs                        = yyyyd -xxyyd'*phis;
	
	lnPY    = -(nvar*(nobs)/2)*log(2*pi)-(nobs/2)*log(det(sigs))-.5*sum(diag(inv(sigs)*(YYYY-2*phis'*XXYY+phis'*XXXX*phis)));
    
% Prior
	lnPRIOR = priodens(para,pmean,pstdd,pshape);
	
% Posterior Kernel
	obj     = real( lnPY + lnPRIOR );
