%! This function is related to " marglhnew.m " in the original DNS formulation
%! Modified to take FAVAR structure into account
function [PO, PY] = CFP_ObjFcnPKmh(para,bounds,yyyy,wwyy,wwww,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,FFFFt,yyyyd,xxyyd,xxxxd,retcode);

    if any(para > bounds(:,2)) | any(para < bounds(:,1))
	    PO = -1E6;
	    PY = -1E20;
    else        
    % POSTERIOR: MLE + DSGE + TRAINING SAMPLE        
		if eq( retcode, 0 )
			%> inderterminacy case
			PY = -1E10;
		else
            %| FULL PRIOR
                m       = size( yyyy, 1);
                p       = nlags;
            if not( isempty( FFFFt ) )
                wwyyd   = zeros( size(wwyy) );
                wwwwd   = zeros( size(wwww) );
                wwwwd(1: 1 + m*p, 1: 1 + m*p )         = xxxxd;
                wwwwd(2 + m*p : end, 2 + m*p : end )   = FFFFt;
                wwyyd(1: 1 + m*p, : )                  = xxyyd;
                wwyyd(2 + m*p : end, : )               = zeros( size(FFFFt, 1), m );
            else
                wwwwd   = xxxxd;
                wwyyd   = xxyyd;
            end
            [k1, k2]= size( wwyyd);
            %keyboard, %plot( [ reshape( wwww(14:25, 14:25), 144, 1 )/80, reshape( FFFFt, 144, 1 ) ] )            
            %| POSTERIOR
                wwyy  = wwyy(1:k1, 1:k2);
                wwww  = wwww(1:k1, 1:k1);
			    yyyyc = yyyy + lambda*yyyyd;
			    wwyyc = wwyy + lambda*wwyyd;
			    wwwwc = wwww + lambda*wwwwd;                
            %| DEGREES OF FREEDOM
			    T   = nobs;
                k   = size( wwyyc, 1 );
                vt  = lambda - k;
                vb  = T + lambda - k;			
			%| VCV
			    Sig_hat     = ( yyyyc -wwyyc'*( wwwwc \ eye(k) )*wwyyc ) / (vb + k);
			    Sig_hatd    = yyyyd - wwyyd'*( wwwwd \ eye(k) )*wwyyd;
            %| MDD
                nobsc  = vb + k;                
				lnkapt = (-nvar*(nobs)/2)*log(2*pi) + ((nobs)*nvar/2)*log(2);
                for i = 1:nvar
                    lnkapt = lnkapt+gammaln((nobsc-k+1-i)/2)-gammaln((lambda-k+1-i)/2);
                end
				PYdns= lnkapt  - ((nobsc-k)/2) *log(det(nobsc *Sig_hat )) + ...
                                 ((lambda-k)/2)*log(det(lambda*Sig_hatd)) - ...
                                 (nvar/2)*log(det(wwwwc)/det(lambda*wwwwd));
            %| MDD : My Way
                PY  = (-m*T/2)*log(2*pi) + (m*T/2)*log(2) + MGammaLN( m, vb ) - MGammaLN(m, vt)  - ...
                                                             ( vb/2 ) * lndet( (vb+k)*Sig_hat  ) + ...
                                                             ( vt/2 ) * lndet( (vt+k)*Sig_hatd ) - ...
                                                   (m/2)*( lndet( wwwwc) - lndet(lambda*wwwwd) );
                                                         
                %PY, PYdns
        end
        
        PY  = real(PY);
        PR  = real( priodens(para,pmean,pstdd,pshape) );
        PO  = PY + PR;
    end