% function [lnpost,lnpy] = objfcnmh9(para,bounds,yyyy,xxyy,xxxx,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode);
%
% Original Version : objfcnmh9.m
% See also         : CFP_ObjFcnPKmh.m

function [PO, PY] = CFP_ObjFcnPKmhinf(para,bounds,YYYY,WWYY,WWWW,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,FFFFt,yyyyd,xxyyd,xxxxd,retcode);

	if isempty( FFFFt )    
        XXYY    = WWYY;
        XXXX    = WWWW;
        
	else
        k       = size(WWWW , 2);
        rq      = size(FFFFt, 2);
        XXYY    = WWYY(1:k-rq, :);
        XXXX    = WWWW(1:k-rq, 1:k-rq);
        
	end

if any(para > bounds(:,2)) | any(para < bounds(:,1))
	PO  = -1E6;
	PY  = -1E20;
else
    if retcode == 0
		% inderterminacy
		lnPY = -1E10;
	else
        phis = inv(xxxxd)*xxyyd;
		sigs = yyyyd -xxyyd'*phis;
        lnPY = -(nvar*(nobs)/2)*log(2*pi)-(nobs/2)*log(det(sigs))-.5*sum(diag(inv(sigs)*(YYYY-2*phis'*XXYY+phis'*XXXX*phis)));
	end;

	lnPRIOR = priodens(para,pmean,pstdd,pshape);
	PY      = real(lnPY);
	PO      = PY + real(lnPRIOR);
    
end
