% function obj = objfcnnewinf      (para,YYYY,XXYY,XXXX,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape);
%
% Original Version : objfcnnewinf.m
% See also         : CFP_ObjFcnPKopt.m

function obj = CFP_ObjFcnPKoptinf( para,YYYY,WWYY,WWWW,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,FFFFt);

	if isempty( FFFFt )    
        XXYY    = WWYY;
        XXXX    = WWWW;
        
	else
        k       = size(WWWW , 2);
        rq      = size(FFFFt, 2);
        XXYY    = WWYY(1:k-rq, :);
        XXXX    = WWWW(1:k-rq, 1:k-rq);
        
	end

% Likelihood 
    modelpara = trans(para,trspec);

    [TTT,RRR,valid]             = dsgesolv(modelpara,mspec);
    [yyyyd,xxyyd,xxxxd,retcode] = varprio(TTT,RRR,valid,modelpara,nvar,nlags,mspec,npara);
    phis                        = inv(xxxxd)*xxyyd;
    sigs                        = yyyyd - xxyyd'*phis;

    lnPY    = -(nvar*(nobs)/2)*log(2*pi)-(nobs/2)*log(det(sigs))-.5*sum(diag(inv(sigs)*(YYYY-2*phis'*XXYY+phis'*XXXX*phis)));

% Prior
    lnPRIOR = priodens(modelpara,pmean,pstdd,pshape);
    
% Posterior Kernel :: " Minize the inverse of the likelihood fcn "
    obj = real(-lnPY-lnPRIOR);