% This function calculates the Gamma Factor :: I.Wishart Distribution
%
%   XMPL : m = 4;  T = 100; vt = 25;    %> #Obs + Prior DoF
%          v = T + vt;                  %> Posterior DoF
%          [LG, G] = MGammaLN(m, v)
% 
% Agostino Jun 2006

function [LG, G] = MGammaLN(m, v)

    if le( v + 1 - m, 0 )
        disp (['> MGammaLN :  ', num2str(v + 1 - m, 2)]);
        error( '> MGammaLN : Degrees of Freedom' );
    end
    
    x  = 1 - (1 : m)';
    LG = sum( gammaln( (v + x)./2 ) );
    G  = exp(LG);