
rand( 'state', 180277 );
randn('state', 180277 );

T  = 1000;
e1 = randn(T, 3);
e2 = randn(T, 3);
e3 = randn(T, 3);
e4 = randn(T, 3);

%> MLE
	A11= e1'*e1;
	A12= e1'*e2;
	A21= e2'*e1;
	A22= e2'*e2;
	
	A1 = [A11, A12; A21, A22];
    
%> PRIOR
	B11= e3'*e3/T;
	B22= e4'*e4/T;
    k1 = size(B11, 1);
    k2 = size(B22, 1); 	
	B1 = [B11, zeros(3,3); zeros(3,3), B22]
    
    lambda   = 2 * T;
    LambdaB1 = lambda * [ eye(k1), zeros(k1,k2); zeros(k2,k1) eye(k2)/lambda] * B1
    cLambdaB1= chol( LambdaB1 )'
    
%> POSTERIOR
    dispcat( A1 )
    dispcat( B1 )
    dispcat( lambda * B1 )
    C1 = A1 + lambda * B1;
    
    chol( C1 )

    for ii = [.2 .5 .6 .8 1 2 4 5 8 10 20 30 40] 
        lambda  = ii * T;
        C1      = A1 + lambda * B1;
        C1L     = A1 + lambda * [ eye(k1), zeros(k1,k2); zeros(k2,k1) eye(k2)/lambda] * B1;
        disp( [ii, cond(C1), cond(C1L)] )
        chol( C1 );
        chol( C1L);
    end

