% This function plot a Matrix by using SubPlots
%
% get( THandle(1))
% set( THandle(1),'String', ' +++ Re-Type Chart''s Title +++ ')

function [SHandle, PHandle, THandle] = SPlot(X, OptSet, YLab, TLab)

    global Dates

    n = size(X,2);
    
    if     lt(n, 3)
        c = 1; r = n;
    elseif eq(n,3)
        c = 1; r = 3;
    elseif eq(n, 4)
        c = 2; r = 2;
    elseif gt(n,4) & le(n,6)
        c = 2; r = 3;
    elseif gt(n,6) & le(n,9)
        c = 3; r = 3;
    elseif gt(n,9) & le(n,12)
        c = 3; r = 4;
    elseif gt(n,12) & le(n,16)
        c = 4; r = 4;
    else
        disp('> How Many Graphs do you want to plot ???')
        return
    end
    
    % Bounds 
    if nargin == 3
        jj = [1:r:n];
        for j = 1 : r
            ratio = 1.2;
            Bounds(j, 1) = ratio* min( min( X(:, jj(j):jj(j)+c-1) ) );
            Bounds(j, 2) = ratio* max( max( X(:, jj(j):jj(j)+c-1) ) );        
        end
        BND = kron(Bounds, ones(c, 1)  );
    end
    
    FHandle = figure;
    set(FHandle,'Color', [.5, 0.45, 0.6] );
    for i = 1 : n
        SHandle(i) = subplot(r, c, i);
        if exist( 'Dates' )
            if or( isempty( 'Dates' ), ne( length(Dates), size( X(:,i), 1) ) )
                PHandle(i) = plot( X(:,i) );            grid on;
            else
                PHandle(i) = plot( Dates, X(:,i) );     grid on;
            end
        end
%         PHandle(i) = plot( Dates, X(:,i) );    grid on;
%         PHandle(i) = plot( X(:,i) );    grid on;
        if nargin == 3
            set( SHandle(i), 'Ylim',  BND(i, :) );
        else
            axis tight;
        end
        
        if nargin == 4
            THandle(i) = title( [setstr( 96 + i), ') ', TLab{i} ], 'FontWeight', 'bold', 'FontSize', 11, 'Color', 'k');
%             THandle(i) = title( [ '(', setstr( 96 + i), ') ', TLab{i} ], 'FontWeight', 'bold', 'FontSize', 11, 'Color', 'k');
        else
            THandle(i) = title(['..:: Variable # ', num2str(i), ' ::..']);
        end
        YHandle(i) = ylabel( ' ' );
        set(gca, 'Color', 'w')

        if gt(nargin, 1)
            if and( eq(nargin, 2), not(isempty(OptSet)) )
                YLim( OptSet.YLim );
                grid on;    hold on;
                plot(zeros(size(X(:,i))), 'k')        
            end
        end
  
    end
    
%     if eq(nargin, 2)
%         GText(OptSet.SubTitle01)
%         GText(OptSet.SubTitle02)            
%     end    
    
    if nargin == 3
        for j = 1 : c : n
            set( YHandle(j), 'String', YLab( (j-1)/c + 1, : ) );
        end

        set( THandle(:), 'String', ' ' )
        for j = 1 : 1 : c
            set( THandle(j), 'String', YLab( j + r, : ) );
        end
    end