function aairf = irfdsge(TTT,RRR,para,nvar,mspec,npara,nirf,cum_irf);

nstate = size(TTT,1);

%% create system matrices for state space model
%% see dsgesolv for composition of state vector
zz = zeros(nvar,nstate);
impact = zeros(nvar,nvar);
%% variable, shock
mmm = zeros(nvar,nvar);

if mspec == 2

    impact(1,1) = para(8);
	impact(2,2) = para(9);

    %% state space: [dm(t-1), dp(t-1), dy(t-1), dm(t), dp(t), dk(t+1), dh(t), dy(t), dq(t+1), dqt(t+1), dqb(t+1), R(t)]
    %% output growth
    zz(1,8) = 1; zz(1,3) = -1;
    %% inflation
	zz(2,5) = 1; zz(2,2) = -1; zz(2,1) = 1;


    mmm(:,1) = [1;-1];
elseif ( mspec >= 3 ) & ( mspec <= 6 )

    impact(1,1) = para(8);
	impact(2,2) = para(9);
	 %% Monetary Policy Shock
    if any(mspec == [3 4]); %% for interest rate rule
	 		impact(2,2) = -para(9);
    end

    %% state space: [dm(t-1), dp(t-1), dy(t-1), dm(t), dp(t), dk(t+1), dh(t), dy(t), dq(t+1), dqt(t+1), dqb(t+1), R(t)]
    %% output growth
    zz(1,8) = 1; zz(1,3) = -1;
    %% inflation
	zz(2,5) = 1; zz(2,2) = -1; zz(2,1) = 1;


    mmm(:,1) = [1;-1];

elseif ( mspec == 101 )


    impact(1,1) = para(11);
	impact(2,2) = para(12);
	impact(3,3) = para(13);

    %% state space: [y,inf,r2,r2star,g,z,xi_y,xi_infl,y-1]

    %% output growth
	zz(1,1) = 1; zz(1,9) = -1; zz(1,6) = 1;
    %% inflation
	zz(2,2) = 1;
    %% interest rate
	zz(3,3) = 4;

   %%  mmm(1,3) = 1; CHANGE


end


%% compute irf
aairf = [];
for I = 1:nvar
    imp = impact(:,I);
	ssirf = zeros(nstate,nirf);
	yyirf = zeros(nvar,nirf);

    ssirf(:,1) = RRR*imp;
  	yyirf(:,1) = zz*ssirf(:,1) + mmm*imp;
	for t = 2:nirf;
        ssirf(:,t) = TTT*ssirf(:,t-1);
		yyirf(:,t) = zz*ssirf(:,t);
    end;
	yyirf(cum_irf,:) = cumsum(yyirf(cum_irf,:),2);
	aairf = [aairf,yyirf'];
end

