function pyt = marglhnew(para,yyyy,xxyy,xxxx,nobs,lambda,nlags,nvar,mspec,npara);

% Compute cross product matrices for DSGE dummy observations
[TTT,RRR,valid] = dsgesolv(para,mspec);
[yyyyd,xxyyd,xxxxd,retcode] = varprio(TTT,RRR,valid,para,nvar,nlags,mspec,npara);
if retcode == 0
	% inderterminacy
	pyt = -1E10;
else

	yyyyc = yyyy + lambda*yyyyd;
	xxyyc = xxyy + lambda*xxyyd;
	xxxxc = xxxx + lambda*xxxxd;
	
	nobsc = nobs + lambda;    
	k     = 1+nlags*nvar;
	
	% Compute OLS estimates
	
	Sig_hat = (yyyyc -xxyyc'*inv(xxxxc)*xxyyc)/nobsc;
   
	Sig_hatd = yyyyd -xxyyd'*inv(xxxxd)*xxyyd;
    

	lnkapt = (-nvar*(nobs)/2)*log(2*pi) + ((nobs)*nvar/2)*log(2);
    for i = 1:nvar
        lnkapt = lnkapt+gammaln((nobsc-k+1-i)/2)-gammaln((lambda-k+1-i)/2);
    end
	pyt  = lnkapt  - ((nobsc-k)/2)*log(det(nobsc*Sig_hat)) + ((lambda-k)/2)*log(det(lambda*Sig_hatd)) ...
    - (nvar/2)*log(det(xxxxc)/det(lambda*xxxxd));


end;
