% function [g badg] = numgradvec2(fcn,x,varargin)
% modification of numgrad (Sims' program) when the function is a vector and not a scalar - generally used to 
% get second derivatives when the analytical first derivative is available
% note: the output of fcn must be a kx1 (usually nx1) vector, and the x vector must be nx1
% use this istead of numgradvec

function [g, badg] = numgradvec2(fcn,x,varargin)
delta = 1e-6;
n=length(x);
tvec=delta*eye(n);

f0 = eval([fcn '(x,varargin{:})'])';
g=zeros(n,size(f0,2));


badg=0;
for i=1:n
   scale=1;  % originally 1
   
   if size(x,1)>size(x,2)
      tvecv=tvec(i,:);
   else
      tvecv=tvec(:,i);
   end
   % g0 is 1xk
   g0 = (eval([fcn '(x+scale*tvecv'', varargin{:})'])' - f0) ...
         /(scale*delta);
   if max(abs(g0))< 1e15
      g(i,:)=g0;
   else
      disp('bad gradient ------------------------') % Jinill Kim
      g(i,:)=0;
      badg=1;
   end
end

