function [lnpost,lnpy] = objfcnmh9(para,bounds,yyyy,xxyy,xxxx,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode);

if any(para > bounds(:,2)) | any(para < bounds(:,1))
	lnpost = -1E6;
	lnpy   = -1E20;
else
    if retcode == 0
		% inderterminacy
		lnpy = -1E10;
	else
	
		yyyyc = yyyy + lambda*yyyyd;
		xxyyc = xxyy + lambda*xxyyd;
		xxxxc = xxxx + lambda*xxxxd;
		
		nobsc = nobs + lambda;    
		k     = 1+nlags*nvar;
		
		% Compute OLS estimates
		
		Sig_hat = (yyyyc -xxyyc'*inv(xxxxc)*xxyyc)/nobsc;
       
		Sig_hatd = yyyyd -xxyyd'*inv(xxxxd)*xxyyd;
        
	
		lnkapt = (-nvar*(nobs)/2)*log(2*pi) + ((nobs)*nvar/2)*log(2);
        for i = 1:nvar
            lnkapt = lnkapt+gammaln((nobsc-k+1-i)/2)-gammaln((lambda-k+1-i)/2);
        end
		lnpy  = lnkapt  - ((nobsc-k)/2)*log( det(nobsc*Sig_hat) ) +...
                ( (lambda-k)/2 )*log( det(lambda*Sig_hatd) )      - ...
                (nvar/2)*log( det(xxxxc)/det(lambda*xxxxd) );
	
	
	end;
% keyboard
	lnpy    = real(lnpy);
	lnprio  = priodens(para,pmean,pstdd,pshape);
	lnpost  = lnpy + real(lnprio);
end