% Parameters: alp bet gam lnmst rho 
%             psi del sig_eps sig_eta alp1rt 
% Transformations:
% format: type, a, b, c
% Type 1:
% x is [a,b] -> [-1,1] -> [-inf,inf] by (1/c)*c*z/sqrt(1-c*z^2)
% Type 2:
% x is [0,inf] -> [-inf,inf] by b + (1/c)*ln(para[i]-a);

function trspec = transp(mspec)

if mspec < 3 
    trspec = [...
			1   1E-5   0.99999   1; ...  
			1   0.90   0.99999   1; ...
			0   1E-5   0         1; ...
			0   1E-5   0         1; ... 
			1   1E-5   0.99      1; ...
			1   1E-5   0.99      1; ...
			1   1E-5   0.99      1; ...
			2   1E-5   0         1; ...     
			2   1E-5   0         1; ... 
			2   1E-5   0         1]; 

elseif ( mspec >= 3 ) & ( mspec <= 6 ) 
    trspec = [...
			1   1E-5   0.99999   1; ...                         %% alpha
			1   0.90   0.99999   1; ...                         %% beta
			0   1E-5   0         1; ...                         %% gamma
			0   1E-5   0         1; ...                         %% infl
			1   1E-5   0.99      1; ...                         %% rho
			1   1E-5   0.99      1; ...                         %% psi
			1   1E-5   0.99      1; ...                         %% del
			2   1E-5   0         1; ...                         %% sig_eps
			2   1E-5   0         1; ...                         %% sig_eta
			2   1E-5   0         1; ...                         %% kappa
			2   1E-5   0         1; ...                         %% phi1
			2   1E-5   0         1];                            %% phi2
    
elseif ( mspec == 101 ) | ( mspec == 102 )
    trspec = [...
			0   0      0         0; ...                         %% lngamm
			0   0      0         0; ...                         %% lnpist
			2   1E-5   0         1; ...                         %% lnrrst
			2   1E-5   0         1; ...                         %% kap
			2   1E-5   0         1; ...                         %% tau
			2   1E-5   0         1; ...                         %% psi1
			2   1E-5   0         1; ...                         %% psi2 
			1   1E-5   0.99      1; ...                         %% rhor
			1   1E-5   0.99      1; ...                         %% rhog
			1   1E-5   0.99      1; ...                         %% rhoz
			2   1E-5   0         1; ...                         %% sig_r     
			2   1E-5   0         1; ...                         %% sig_g 
			2   1E-5   0         1];                            %% sig_z   
    
end



