% estimates favar by principal components
% confidence intervals are from a two-step bootstrap
% X is TxN, Y is TxM , F is TxK
% state equation:       [F(t)' Y(t)']'=B(L)[F(t-1)' Y(t-1)']'+v(t), v ~ N(0,Q), Q unrestricted
% X is Stock&Watson balanced panel less Y, observable factors

 %%%Load panel data   

mydir = 'C:\fact\';


simsdata2=strcat(mydir,'panel5903','.xls')
sims22=importdata(simsdata2);
sims2=sims22(2:end,1:132);
nn=size(sims2,1);

%%%%Tranform data from monthly to quarterly
index=[3:3:nn];
sims2=sims2(index,:);

[maxr,maxk]=size(sims2);

%%%Transform series
series=zeros(maxr-3,maxk);

for k=1:maxk 
    series_k=sims2(:,k);
    code=sims22(1,k);
    series1=zeros(maxr-1,1);
    
 [series1]=transf(series_k,series1,maxr,code);


series(1:end,k)=series1(3:end,1);

end


%%%Load Y series

real_series=strcat(mydir,'yy','.xls')
yyyy=importdata(real_series);
yyy=yyyy(2:end,1:3);
nt=size(yyy,1);
index=[3:3:nt];
yyy=yyy(index,:);
[maxrr,maxc]=size(yyy);
 Y=zeros(maxrr-3,maxc);
 
 %%%transform series
for k=1:3
    series_k=yyy(:,k);
    code=yyyy(1:1);

    series1=zeros(maxrr,1);
    
    [series1]=transf(series_k,series1,maxrr,code);
Y(1:end,k)=series1(3:end,1);

end



% need to standardize for PC:
T=size(series,1);
stdffr=std(Y(:,2)) %%%%monetary shock
series=(series-repmat(mean(series,1),T,1))./repmat(std(series,1),T,1);

%%%%%%%%%%%%%%%%%%%%%%%%% choose specification %%%%%%%%%%%%%%%%%%%%%%%%

slowindex=zeros(maxk-3,1);
fastindex=zeros(maxk-3,1);
slowindex([(1:50)'; (113:129)'])=1; % index defined w.r.t. nsbalpanel
fastindex([(51:1:112)'])=1;



nyindex=ones(maxk,1);
yindex=[6 86 115];  %%%%separate y series
nyindex(yindex)=0;

X=series(:,find(nyindex==1));
Y;

numfac=3
K=3
ks=2   %%%slow factors
kf=1   %%%fast factors
lags=4; %%%%lags
nrep1=10; % on observation equation
nrep2=10; % on VAR equation
nsteps=48;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

N=size(X,2);
M=size(Y,2);

shock=[zeros(1,K+M-1) .25/stdffr]'; % in terms of standard deviation, identification is recursive

slowindex=[(1:1:50),(113:1:129)]';
fastindex=[(51:1:112)]';
%%%Extracting factors and eigenvalue
[FYresp,F0,Fslow0,Ffast,evals,evalf]=irfvarcomp(Y,lags,X,slowindex,fastindex,K,ks,kf,shock,nsteps-1);	% nsteps x equations x error bands


   
   %%%Calculate max eigen
[r,c]=size(evals);
evaltot=sum(evals);
eval3=sum(evals(r-1:r,1));
var_expls=eval3/evaltot

[r,c]=size(evalf);
evaltot=sum(evalf);
eval4=sum(evalf(r,1));
var_explf=eval4/evaltot

%%%3 factors
fact=[Fslow0,Ffast]